;  AutoCAD Menu Auto-Layering System
;
;  Copywrite 1990 by Gregory Green, LaserWorks Consultants:
;
;         PUSH_LAYR, POP_LAYR, SLAYR, RLAYR and S::STARTUP
;
(setvar "CMDECHO" 0)
(setvar "MENUECHO" 1)
(setq VVV 'atomlist)
(vmon)
;
;  This routine will set the drawing to the base layer during startup -- may be
;  changed to any other layer desired by the user (substitute layer name for 
;  "0" in the line 'command  "layer" "s" "<user_layer_name>" "" ' below.
;
(defun S::STARTUP ( / clyr)
  (setvar "cmdecho" 0)
  (setq clyr (getvar "clayer"))
  (if (/= clyr "0")
    (command  "layer" "s" "0" "")
  )
  (princ)
)
(defun PUSH_LAYR (n)
  (setvar "cmdecho" 0)
  (setq layr_stk (cons n layr_stk))
)
(defun POP_LAYR ()
  (setvar "cmdecho" 0)
  (setq n (car layr_stk))
  (setq layr_stk (cdr layr_stk))
  (eval n)
)
(defun SLAYR (a)
  (setvar "cmdecho" 0)
  (push_layr (getvar "clayer"))
  (command "layer" "s" a "")
  (princ)
)
(defun RLAYR ()
  (setvar "cmdecho" 0)
  (setq clyr (pop_layr))
  (command "layer" "s" clyr "")
  (princ)
)
;
;  Optional AutoLISP error routine to prevent the "run-back" if an error occurs
;  during excution of an AutoLISP routine or if Ctrl-C (cancel) is performed.
;
(defun *error* (msg)
   (princ "\nERROR: ")
   (princ msg)
   (terpri)
   (princ)
)
